/*
 * Google Analytics
 * Date: 3/27/2023
 */
define(function () {

    const install = function (context) {
        var tagId = context.getParameter("GA4Tag");
        var isDebug = context.getParameter("Debug") == 1; // using == here because parameter returns strings

        var ga4TagUrl = tagId ? "//www.googletagmanager.com/gtag/js?id=" + tagId : null;

        require([ga4TagUrl], function (unused1) {
            if (isDebug) {
                console.log("google-analytics - loaded gtag.js");
            }

            if (tagId) {
                installGA4(context);
            }
        });
    };

    const installGA4 = function (context) {
        var tagId = context.getParameter("GA4Tag");

        var isDebug = context.getParameter("Debug") == 1; // using == here because parameter returns strings
        if (isDebug) {
            console.log("google-ga4 - create with GA4Tag", tagId);
        }

        window.dataLayer = window.dataLayer || [];
        function gtag() { dataLayer.push(arguments); }
        gtag('js', new Date());

        // set a call back for when the browser location changes (new page loads)
        // Note: this doesn't run when we change things like selected row
        const handlePageLocationChange = function (path) {
            if (isDebug) {
                console.log("google-ga4 - define path", path);
            }

            gtag('config', tagId, { 'page_path': path });
        }

        const pageLocation = context.getCurrentPageLocation();
        handlePageLocationChange(pageLocation);

        context.onPageLocationChange(handlePageLocationChange);
    }

    return {
        callbacks: {
            install: install
        }
    };
});